"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var gojs_1 = require("gojs");
var modelChangedhandler_1 = require("./modelChangedhandler");
var GojsDiagram = /** @class */ (function (_super) {
    __extends(GojsDiagram, _super);
    function GojsDiagram(props) {
        var _this = _super.call(this, props) || this;
        _this.modelChangedHandlers = [
            new modelChangedhandler_1.AddNodeModelChangedHandler(),
            new modelChangedhandler_1.AddLinkModelChangedHandler(),
            new modelChangedhandler_1.RemoveNodeModelChangedHandler(),
            new modelChangedhandler_1.RemoveLinkModelChangedHandler(),
            new modelChangedhandler_1.GroupNodeModelChangedHandler(),
            new modelChangedhandler_1.BeginTransactionHandler(),
            new modelChangedhandler_1.CommitTransactionHandler()
        ];
        _this.divRef = React.createRef();
        _this.eventsToDispatch = [];
        _this.modelChangedHandler = _this.modelChangedHandler.bind(_this);
        return _this;
    }
    GojsDiagram.prototype.componentDidMount = function () {
        var _this = this;
        if (this.divRef.current) {
            var prevValue_1 = JSON.stringify(this.divRef.current.getBoundingClientRect());
            this.mountInterval = setInterval(function () {
                if (_this.divRef.current) {
                    var nextValue = JSON.stringify(_this.divRef.current.getBoundingClientRect());
                    if (nextValue === prevValue_1 &&
                        _this.divRef.current.getBoundingClientRect().height &&
                        _this.divRef.current.getBoundingClientRect().width) {
                        clearInterval(_this.mountInterval);
                        _this.init();
                    }
                    else {
                        prevValue_1 = nextValue;
                    }
                }
                else {
                    clearInterval(_this.mountInterval);
                }
            }, 50);
        }
    };
    GojsDiagram.prototype.componentWillUnmount = function () {
        if (this.myDiagram && this.props.onModelChange) {
            this.myDiagram.removeModelChangedListener(this.modelChangedHandler);
        }
        if (this.myDiagram) {
            this.myDiagram.clear();
        }
        if (this.mountInterval) {
            clearInterval(this.mountInterval);
        }
    };
    GojsDiagram.prototype.componentDidUpdate = function () {
        if (this.myDiagram) {
            this.myDiagram.startTransaction();
            this.applyAddRemoveLinksFromModel();
            this.applyAddRemoveNodesFromModel();
            this.applyUpdatesFromModel();
            if (this.props.updateDiagramProps) {
                this.props.updateDiagramProps(this.myDiagram);
            }
            this.myDiagram.updateAllRelationshipsFromData();
            this.myDiagram.updateAllTargetBindings();
            this.myDiagram.commitTransaction('updated');
        }
    };
    GojsDiagram.prototype.init = function () {
        var _a = this.props, createDiagram = _a.createDiagram, diagramId = _a.diagramId, onModelChange = _a.onModelChange, defaultSelectedNode = _a.defaultSelectedNode;
        this.myDiagram = createDiagram(diagramId);
        if (onModelChange) {
            this.myDiagram.addModelChangedListener(this.modelChangedHandler);
        }
        this.myDiagram.model = gojs_1.GraphObject.make(gojs_1.GraphLinksModel, __assign(__assign(__assign({}, (this.props.makeUniqueKeyFunction && {
            makeUniqueKeyFunction: this.props.makeUniqueKeyFunction
        })), { linkFromPortIdProperty: this.props.linkFromPortIdProperty || '', linkToPortIdProperty: this.props.linkToPortIdProperty || '', nodeDataArray: __spreadArrays(this.props.model.nodeDataArray), linkDataArray: __spreadArrays(this.props.model.linkDataArray), nodeCategoryProperty: this.props.nodeCategoryProperty || 'category', linkKeyProperty: this.props.linkKeyProperty || '', makeUniqueLinkKeyFunction: this.props.makeUniqueLinkKeyFunction || null, copyNodeDataFunction: this.props.copyNodeDataFunction || null }), (this.props.initialModelData && { modelData: this.props.initialModelData })));
        if (defaultSelectedNode) {
            this.myDiagram.select(this.myDiagram.findNodeForKey(defaultSelectedNode));
        }
    };
    GojsDiagram.prototype.render = function () {
        return React.createElement("div", { ref: this.divRef, id: this.props.diagramId, className: this.props.className });
    };
    GojsDiagram.prototype.enqueueEvent = function (event) {
        this.eventsToDispatch = this.eventsToDispatch.concat(event);
    };
    GojsDiagram.prototype.clear = function () {
        this.eventsToDispatch = [];
    };
    GojsDiagram.prototype.dispatchAll = function () {
        var _this = this;
        this.eventsToDispatch.forEach(function (eventToDispatch) { return _this.props.onModelChange(eventToDispatch); });
        this.eventsToDispatch = [];
    };
    GojsDiagram.prototype.modelChangedHandler = function (evt) {
        var _this = this;
        this.modelChangedHandlers.forEach(function (handler) {
            if (handler.canHandle(evt)) {
                handler.handle(evt, _this.props.model, _this);
            }
        });
    };
    GojsDiagram.prototype.applyAddRemoveNodesFromModel = function () {
        var _this = this;
        var nodesToAdd = this.props.model.nodeDataArray
            .filter(function (e) { return _this.myDiagram.model.nodeDataArray.findIndex(function (el) { return el.key === e.key; }) === -1; })
            .map(function (node) { return Object.assign({}, node); });
        this.myDiagram.model.addNodeDataCollection(nodesToAdd);
        var nodesToRemove = this.myDiagram.model.nodeDataArray.filter(function (e) { return _this.props.model.nodeDataArray.findIndex(function (el) { return el.key === e.key; }) === -1; });
        this.myDiagram.model.removeNodeDataCollection(nodesToRemove);
    };
    GojsDiagram.prototype.applyAddRemoveLinksFromModel = function () {
        var _this = this;
        var linksToAdd = this.props.model.linkDataArray
            .filter(function (e) {
            return _this.myDiagram.model.linkDataArray.findIndex(function (el) {
                if (_this.props.linkKeyProperty &&
                    el[_this.props.linkKeyProperty] &&
                    e[_this.props.linkKeyProperty]) {
                    return (el.from === e.from &&
                        el.to === e.to &&
                        el[_this.props.linkKeyProperty] === e[_this.props.linkKeyProperty]);
                }
                return el.from === e.from && el.to === e.to;
            }) === -1;
        })
            .map(function (link) { return Object.assign({}, link); });
        this.myDiagram.model.addLinkDataCollection(linksToAdd);
        var linksToRemove = this.myDiagram.model.linkDataArray.filter(function (e) {
            return _this.props.model.linkDataArray.findIndex(function (el) {
                if (_this.props.linkKeyProperty && el[_this.props.linkKeyProperty] && e[_this.props.linkKeyProperty]) {
                    return (el.from === e.from &&
                        el.to === e.to &&
                        el[_this.props.linkKeyProperty] === e[_this.props.linkKeyProperty]);
                }
                return el.from === e.from && el.to === e.to;
            }) === -1;
        });
        this.myDiagram.model.removeLinkDataCollection(linksToRemove);
    };
    GojsDiagram.prototype.applyUpdatesFromModel = function () {
        this.myDiagram.model.applyIncrementalJson({
            class: 'GraphLinksModel',
            incremental: 1,
            nodeKeyProperty: 'key',
            linkKeyProperty: 'key',
            linkFromPortIdProperty: this.props.linkFromPortIdProperty || '',
            linkToPortIdProperty: this.props.linkToPortIdProperty || '',
            modifiedNodeData: this.props.model.nodeDataArray,
            modifiedLinkData: this.props.model.linkDataArray
        });
    };
    return GojsDiagram;
}(React.PureComponent));
exports.default = GojsDiagram;
//# sourceMappingURL=GojsDiagram.js.map